(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tslib')) :
    typeof define === 'function' && define.amd ? define(['exports', 'tslib'], factory) :
    (global = global || self, factory(global['async-bulk-map'] = {}, global.tslib_1));
}(this, function (exports, tslib_1) { 'use strict';

    function asyncBulkMap(arr, bulkSize, actions) {
      return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _a, res, i, bulk, _b, bulkRes, _c, _d;

        return tslib_1.__generator(this, function (_e) {
          switch (_e.label) {
            case 0:
              _a = actions.beforeAll;
              if (!_a) return [3
              /*break*/
              , 2];
              return [4
              /*yield*/
              , actions.beforeAll(arr)];

            case 1:
              _a = _e.sent();
              _e.label = 2;

            case 2:
              arr = _a || arr;
              res = [];
              i = 0;
              _e.label = 3;

            case 3:
              if (!(i < Math.max(arr.length / bulkSize, 1))) return [3
              /*break*/
              , 10];
              bulk = arr.slice(i * bulkSize, i * bulkSize + bulkSize);
              _b = actions.beforeBulk;
              if (!_b) return [3
              /*break*/
              , 5];
              return [4
              /*yield*/
              , actions.beforeBulk(bulk, i)];

            case 4:
              _b = _e.sent();
              _e.label = 5;

            case 5:
              bulk = _b || bulk;
              return [4
              /*yield*/
              , Promise.all(bulk.map(function (item) {
                return actions.map(item);
              }))];

            case 6:
              bulkRes = _e.sent();
              _c = actions.afterBulk;
              if (!_c) return [3
              /*break*/
              , 8];
              return [4
              /*yield*/
              , actions.afterBulk(bulkRes)];

            case 7:
              _c = _e.sent();
              _e.label = 8;

            case 8:
              bulkRes = _c || bulkRes;
              res = res.concat(bulkRes);
              _e.label = 9;

            case 9:
              i++;
              return [3
              /*break*/
              , 3];

            case 10:
              _d = actions.afterAll;
              if (!_d) return [3
              /*break*/
              , 12];
              return [4
              /*yield*/
              , actions.afterAll(res)];

            case 11:
              _d = _e.sent();
              _e.label = 12;

            case 12:
              return [2
              /*return*/
              , _d || res];
          }
        });
      });
    }

    function createPipe(pipeSrc) {
      return createFunctionsPipe([pipeSrc]);
    }

    function createFunctionsPipe(pipeFns) {
      return Object.assign(function asyncReduce() {
        var args = [];

        for (var _i = 0; _i < arguments.length; _i++) {
          args[_i] = arguments[_i];
        }

        return tslib_1.__awaiter(this, void 0, void 0, function () {
          var res, pipeFns_1, pipeFns_1_1, currFn, e_1_1;

          var e_1, _a;

          return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
              case 0:
                res = args;
                _b.label = 1;

              case 1:
                _b.trys.push([1, 6, 7, 8]);

                pipeFns_1 = tslib_1.__values(pipeFns), pipeFns_1_1 = pipeFns_1.next();
                _b.label = 2;

              case 2:
                if (!!pipeFns_1_1.done) return [3
                /*break*/
                , 5];
                currFn = pipeFns_1_1.value;
                return [4
                /*yield*/
                , currFn.apply(void 0, tslib_1.__spread(res || args))];

              case 3:
                res = _b.sent();
                _b.label = 4;

              case 4:
                pipeFns_1_1 = pipeFns_1.next();
                return [3
                /*break*/
                , 2];

              case 5:
                return [3
                /*break*/
                , 8];

              case 6:
                e_1_1 = _b.sent();
                e_1 = {
                  error: e_1_1
                };
                return [3
                /*break*/
                , 8];

              case 7:
                try {
                  if (pipeFns_1_1 && !pipeFns_1_1.done && (_a = pipeFns_1["return"])) _a.call(pipeFns_1);
                } finally {
                  if (e_1) throw e_1.error;
                }

                return [7
                /*endfinally*/
                ];

              case 8:
                return [2
                /*return*/
                , res];
            }
          });
        });
      }, {
        pipe: function pipe(nextFn) {
          pipeFns.push(nextFn);
          return this;
        },
        then: function then(nextFn) {
          return createFunctionsPipe(pipeFns.concat(nextFn));
        }
      });
    }

    function logBulk(bulk, bulkIndex) {
      console.log("bulk index: " + bulkIndex + " (" + bulk.length + " entries)");
    }
    function createDelay(timeout) {
      return function () {
        return new Promise(function (resolve) {
          return setTimeout(resolve, timeout);
        });
      };
    }

    exports.asyncBulkMap = asyncBulkMap;
    exports.createDelay = createDelay;
    exports.createPipe = createPipe;
    exports.logBulk = logBulk;

}));
//# sourceMappingURL=async-bulk-map.umd.development.js.map
